/* 
   Copyright 1994-2003 Free Software Foundation, Inc.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
   USA

   You may contact the author at:

   mailto::camille@bluegrass.net

   or by snail mail at:

   David Lindauer
   850 Washburn Ave Apt 99
   Louisville, KY 40222
*/
#include <io.h>
#include <dos.h>
#include <errno.h>
#include <sys\locking.h>

int _RTL_FUNC locking(int __handle, int __cmd, long __length)
{
   long ft = tell(__handle) ;
   int i ;
   if (ft == -1)  /* will catch invalid handle */
      return -1 ;
   switch(__cmd) {
      case LK_LOCK:
      case LK_RLCK:
         for (i =0; i < 10; i++) {
            if (! lock(__handle, ft, __length))
               return 0 ;
            sleep(1) ;
         }
         errno = EDEADLOCK ;
         return -1 ;
      case LK_NBLCK:
      case LK_NBRLCK:
         return lock(__handle, ft, __length) ;
      case LK_UNLCK:
         return unlock(__handle, ft, __length) ;
      default:
         errno = EINVAL ;
         return -1 ;
   }

}
int _RTL_FUNC _locking(int __handle, int __cmd, long __length)
{
	return locking(__handle, __cmd, __length);
}
